/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */
package org.apache.mina.transport.socket;

import org.apache.mina.common.AbstractIoSessionConfig;
import org.apache.mina.common.IoSessionConfig;

/**
 * @author The Apache MINA Project (dev@mina.apache.org)
 * @version $Rev: 576455 $, $Date: 2007-09-17 08:39:24 -0600 (Mon, 17 Sep 2007) $
 */
public abstract class AbstractDatagramSessionConfig extends
        AbstractIoSessionConfig implements DatagramSessionConfig {

    protected AbstractDatagramSessionConfig() {
    }

    @Override
    protected void doSetAll(IoSessionConfig config) {
        if (config instanceof DatagramSessionConfig) {
            DatagramSessionConfig cfg = (DatagramSessionConfig) config;
            setBroadcast(cfg.isBroadcast());
            setReceiveBufferSize(cfg.getReceiveBufferSize());
            setReuseAddress(cfg.isReuseAddress());
            setSendBufferSize(cfg.getSendBufferSize());

            if (getTrafficClass() != cfg.getTrafficClass()) {
                setTrafficClass(cfg.getTrafficClass());
            }
        }
    }

}